<?php

namespace EventPortal\Domain\EventSpeaker\Actions;

use EventPortal\Domain\Event\Models\Event;

class AssociateToEvent
{
    public function execute(Event $event, array $speakers): void
    {
        $currentSpeakers = $event->fresh()->speakers;

        $speakers = collect($speakers)
            ->reject(static function ($speakerId) use ($currentSpeakers) {
                return $currentSpeakers->contains('id', $speakerId);
            })
            ->toArray();

        $event->speakers()->attach($speakers);
    }
}
